sentence = "This is the time -- and this is the record of the time."
words = sentence.split()
len(words)

len(set(words))

words[2]

words[2] == words[8]

words[2] is words[8]

words[2] is words[2]

set(words)

word_types = set(text.split())
sorted(word_types)

print len(word_types)

from StringIO import StringIO
def fake_open(filename, mode=None):
    return StringIO('Hello World!\nThis is a test file.\n')
def fake_urlopen(url):
    return StringIO(' BBC NEWS | News Front Page News Sport '
                    'Weather World Service')
open = fake_open
import urllib
urllib.urlopen = fake_urlopen

f = open('corpus.txt', 'rU')

f = open('corpus.txt', 'rU')

import os
os.listdir('.')

f.read() 

text = open('corpus.txt', 'rU').read()

f = open('corpus.txt', 'rU')
for line in f:
    print line[:-1]

from urllib import urlopen
page = urlopen("http://news.bbc.co.uk/").read()
print page[:60]

line = '<title>BBC NEWS | News Front Page</title>'
import re
new = re.sub(r'<.*>', '', line)

new

import re
page = re.sub('<[^>]*>', '', page)
page = re.sub('\s+', ' ', page)
print page[:60]

from nltk_lite.corpora import gutenberg
gutenberg.items

count = 0
for word in gutenberg.raw('whitman-leaves'):
    count += 1
print count

from nltk_lite.corpora import brown
brown.items

from nltk_lite.corpora import extract
print extract(0, brown.raw())

from nltk_lite import tokenize
text = '''Hello.  Isn't this fun?'''
pattern = r'\w+|[^\w\s]+'
list(tokenize.regexp(text, pattern))

import re
text = 'That poster costs $22.40.'
pattern = re.compile(r'''
    \w+               # sequences of 'word' characters
  | \$?\d+(\.\d+)?    # currency amounts, e.g. $12.50
  | [\A\.]+           # abbreviations, e.g. U.S.A.
  | [^\w\s]+          # sequences of punctuation
''', re.VERBOSE)
list(tokenize.regexp(text, pattern))

list(tokenize.regexp(text, pattern=r'\s+', gaps=True))

text = 'That poster costs $22.40.'
list(tokenize.whitespace(text))

from nltk_lite import stem
stemmer = stem.Porter()
verbs = ['appears', 'appear', 'appeared', 'calling', 'called']
stems = []
for verb in verbs:
    stemmed_verb = stemmer.stem(verb)
    if stemmed_verb not in stems:
        stems.append(stemmed_verb)
stems

str = 'This is THE time'
str.lower()

sent = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
[word.lower() for word in sent]

[stemmer.stem(verb) for verb in verbs]

set(stemmer.stem(verb) for verb in verbs)

def is_lexical(word):
    return word.lower() not in ('a', 'an', 'the', 'that', 'to')
[word for word in sent if is_lexical(word)]

[word.lower() for word in sent if is_lexical(word)]

sent = extract(0, brown.raw())
[(x, stemmer.stem(x).lower()) for x in sent]

sent = ['The', 'dog', 'gave', 'John', 'the', 'newspaper']
result = []
for word in sent:
    word_len = (word, len(word))
    result.append(word_len)
result

words = ['attribution', 'confabulation', 'elocution',
         'sequoia', 'tenacious', 'unidirectional']
vsequences = set()
for word in words:
    vowels = []
    for char in word:
        if char in 'aeiou':
            vowels.append(char)
    vsequences.add(vowels)
sorted(vsequences)

from nltk_lite.corpora import cmudict
from string import join
for word, num, pron in cmudict.raw():
    if pron[-4:] == ('N', 'IH0', 'K', 'S'):
        print word.lower(),

from nltk_lite.wordnet import *
car = N['motorcar']
car

len(car)

car[0]

[word for word in car[0]]

car[0].gloss

poly = N['pupil']
for synset in poly:
    print synset

poly[2].gloss

for concept in car[0][HYPONYM][:10]:
	print concept

car[0][HYPERNYM]

from pprint import pprint
pprint(N['car'][0].tree(HYPERNYM))

animals = N['animal'][0].closure(HYPONYM, depth=4)
[word for synset in animals for word in synset if word in V]

from nltk_lite.wordnet import *
N['poodle'][0].path_similarity(N['dalmatian'][1])

N['dog'][0].path_similarity(N['cat'][0])

V['run'][0].path_similarity(V['walk'][0])

V['run'][0].path_similarity(V['think'][0])

counts = {}
for word in text.split():
    if word not in counts:
        counts[word] = 0
    counts[word] += 1

for word in sorted(counts)[:10]:
    print counts[word], word

print counts['might']

from nltk_lite.corpora import gutenberg
from nltk_lite.draw import dispersion
words = ['Elinor', 'Marianne', 'Edward', 'Willoughby']
dispersion.plot(gutenberg.raw('austen-sense'), words)

from nltk_lite.probability import FreqDist
from nltk_lite.corpora import genesis
fd = FreqDist()
for token in genesis.raw():
    fd.inc(token)
fd.max()

def length_dist(text):
    fd = FreqDist()                        # initialize frequency distribution
    for token in genesis.raw(text):        # for each token
        fd.inc(len(token))                 # found a word with this length
    for i in range(1,15):                  # for each length from 1 to 14
        print "%2d" % int(100*fd.freq(i)), # print the percentage of words with this length
    print

length_dist('english-kjv')

length_dist('finnish')

from nltk_lite.corpora import genesis
from nltk_lite.probability import ConditionalFreqDist
cfdist = ConditionalFreqDist()
for text in genesis.items:
    for word in genesis.raw(text):
        cfdist[word[0]].inc(len(word))

for cond in cfdist.conditions():
    wordlens = cfdist[cond].samples()
    wordlens.sort()
    points = [(i, cfdist[cond].freq(i)) for i in wordlens]

Plot(points).mainloop()

from nltk_lite.corpora import genesis
from nltk_lite.probability import ConditionalFreqDist
cfdist = ConditionalFreqDist()

prev = None
for word in genesis.raw():
    cfdist[prev].inc(word)
    prev = word

word = 'living'
cfdist[word].samples()

word = 'living'
for i in range(20):
    print word,
    word = cfdist[word].max()

